#!jtager-batch-commands
#
# s3c2410-init.bat
#
# NOTE: This is a board-level initialization file for the
# devel-board based on the Samsung S3C2410 processor.
#

#
# At first, we put the processor into Supervisor-mode, and disable interrupt.
#
reg --name=cpsr --value=0x000000D3

#
# Setup processor clock
#
memset 0x4c000004 --value=0x00070042 	# MPLLCON reg
memset 0x4c000008 --value=0x00058042	# UPLLCON reg
memset 0x4c00000c --value=0x0007fff0	# CLKCON reg
memset 0x4c000010 --value=0x00000004	# CLKSLOW reg
memset 0x4c000014 --value=0x00000000	# CLKDIVN reg

memset 0x56000070 --value=0x00280000	# GPHCON reg
memset 0x56000080 --value=0x00000330	# MISCCR reg

#
# Setup memory controller
#
memset 0x48000000 --value=0x220ed140 	# BWSCON reg
memset 0x48000004 --value=0x00000700 	# BANKCON0 reg
memset 0x48000008 --value=0x00001f7c 	# BANKCON1 reg
memset 0x4800000c --value=0x00000700 	# BANKCON2 reg
memset 0x48000010 --value=0x00001f7c 	# BANKCON3 reg
memset 0x48000014 --value=0x00000740 	# BANKCON4 reg
memset 0x48000018 --value=0x00000700 	# BANKCON5 reg
memset 0x4800001c --value=0x00018001 	# BANKCON6 reg
memset 0x48000020 --value=0x00018001 	# BANKCON7 reg
memset 0x48000024 --value=0x00860459 	# REFRESH reg
memset 0x48000028 --value=0x00000032 	# BANKSIZE reg
memset 0x4800002c --value=0x00000020 	# MRSRB6 reg
memset 0x48000030 --value=0x00000020 	# MRSRB7 reg

#
# S3C44B0X CPU Wrapper Initialization (optional)
#
#memset 0x01c00000 --value=0x08       	# SYSCFG reg
#memset 0x01c00004 --value=0xc0002000 	# NCACHBE0 reg
#memset 0x01c00008 --value=0x00       	# NCACHBE1 reg
#memset 0x01c40000 --value=0x80001b1b 	# SBUSCON reg

#
# Setup S3C44B0X GPIO Ports
#
# NOTE: Because the GPIO ports shares cpu pins with UART0/1,
# it is very important to setup GPIO ports correctly for using
# UART0/1.
#
#memset 0x01d20000 --value=0x1FF		# PCONA reg
#memset 0x01d20004 --value=0x00		# PDATA reg
#memset 0x01d20008 --value=0x3FF		# PCONB reg
#memset 0x01d2000C --value=0x3FF		# PDATB reg
#memset 0x01d20010 --value=0x0F000054	# PCONC reg
#memset 0x01d20014 --value=0xFFFF	# PDATC reg
#memset 0x01d20018 --value=0x3000	# PUPC reg
#memset 0x01d2001C --value=0x00		# PCOND reg
#memset 0x01d20020 --value=0xFF		# PDATD reg
#memset 0x01d20024 --value=0x00		# PUPD reg
#memset 0x01d20028 --value=0x15569	# PCONE reg
					# PE2 = RxD0, PE1 = TxD0
#memset 0x01d2002C --value=0x1FF		# PDATE reg
#memset 0x01d20030 --value=0x06		# PUPE reg
#memset 0x01d20034 --value=0x9240A	# PCONF reg
#memset 0x01d20038 --value=0x1FF		# PDATF reg
#memset 0x01d2003C --value=0x1E3		# PUPF reg
#memset 0x01d20040 --value=0xFFFF	# PCONG reg
#memset 0x01d20044 --value=0xFF		# PDATG reg
#memset 0x01d20048 --value=0x00		# PUPG reg
#memset 0x01d2004C --value=0x07		# SPUCR reg
#memset 0x01d20050 --value=0x00		# EXTINT reg
#memset 0x01d20054 --value=0x00		# EXTINTPND reg

#
# Turn on LED (This is specific to my board!) (optional)
#
# The LED on my board is controlled by PDATF[8:5] of I/O Port F.
# For example:
#   - If PDATF[5] is set to 0, LED0 is turned on.
#   - If PDATF[5] is set to 1, LED0 is turned off.
#
#memset 0x01d20038 --value=0x1F 		# Turn on LED

#
# Setup S3C44B0X UART0
#
#memset 0x01d00000 --value=0x03 		# ULCON0 reg
#memset 0x01d00004 --value=0x205 	# UCON0 reg
#memset 0x01d00008 --value=0x0 		# UFCON0 reg
#memset 0x01d0000c --value=0x0 		# UMCON0 reg
#memset 0x01d00028 --value=32 		# UBRDIV0 reg, buadrate = 115200

#
# Say hello to the world, by UART0
#
#memset 0x01d00020 --size=1b --value=43 		# print char '+'
