#!jtager-batch-commands
#
# s3c4510b-init.bat
#
# NOTE: This is a board-level initialization file for the
# devel-board based on the S3C4510B processor.
#

#
# At first, we put the processor into Supervisor-mode, and disable interrupt.
#
reg --name=cpsr --value=0x000000D3

#
# Setup System Manager
#
memset 0x3FF0000 --value=0xE7FFFF96 	# *** SYSCFG reg ***
					# SDM (bit[31]) = 1, SDRAM
					# PD_ID = 11001 = S3C4510B
					# Special Register Bank Base Pointer = (0x3FF << 16) = 0x3FF0000
					# Internal SRAM Base Pointer = (0x3FE << 16) = 0x3FE0000
					# Cache Mode = 01 = 0-Kbyte SRAM, 8 Kbyte cache
					# Writebuffer Enable = 1, Cache Enable = 1, Stall Enable = 0

memset 0x3FF3000 --value=0x00 	 	# CLKCON reg
memset 0x3FF3008 --value=0x00    	# EXTACON0 reg
memset 0x3FF300C --value=0x00    	# EXTACON1 reg
memset 0x3FF3010 --value=0x06603002	# *** EXTDBWTH reg ***
					# DSR0 (ROM Bank #0) = 10 = Half-word (16-bit)
					# DSR1 - DSR5 = 00 = Disable
					# DSD0 (DRAM Bank #0) = 11 = Word (32-bit)
					# DSD1 - DSD3 = 00 = Disable
					# DSX0 = DSX3 = 01 = Byte (8-bit)

memset 0x3FF3014 --value=0x02000060	# *** ROMCON0 reg ***
					# PMC (bit[1:0]) = 00 (Normal ROM)
					# tPA (bit[3:2]) = 00 (5 cycles)
					# tACC (bit[6:4]) = 110 (7 cycles)
					# ROM Bank #0 Base Pointer = (0x000 << 16) = 0x0000000
					# ROM Bank #0 Next Pointer = (0x020 << 16) = 0x0200000 = 2M
memset 0x3FF3018 --value=0x00000060 	# ROMCON1 reg, ROMCON1 - ROMCON5 are unused.
memset 0x3FF301C --value=0x00000060 	# ROMCON2 reg
memset 0x3FF3020 --value=0x00000060 	# ROMCON3 reg
memset 0x3FF3024 --value=0x00000060 	# ROMCON4 reg
memset 0x3FF3028 --value=0x00000060 	# ROMCON5 reg

memset 0x3FF302C --value=0x12008380	# *** DRAMCON0 ***
					# EDO (bit[0]) = 0 (Normal DRAM)
					# tCS (bit[2:1]) = 00, 1 cycle
					# tCP (bit[3]) = 0, 1 cycle
					# tRC (bit[7]) = 1, 2 cycles
					# tRP (bit[9:8]) = 11, 4 cycles
					# DRAM Bank #0 Base Pointer = (0x020 << 16) = 2M
					# DRAM Bank #0 Next Pointer = (0x120 << 16) = 18M
					# CAN (bit[31:30]) = 00, 8 bits
memset 0x3FF3030 --value=0x00000000	# DRAMCON1 reg, DRAMCON1 - DRAMCON3 are unused.
memset 0x3FF3034 --value=0x00000000 	# DRAMCON2 reg
memset 0x3FF3038 --value=0x00000000 	# DRAMCON3 reg
memset 0x3FF303C --value=0xCE278360	# *** REFEXTCON reg ***
					# External I/O Bank #0 Base Pointer = 0x360 << 16 = 0x3600000
					# VSF (bit[15]) = 1, Accessible to memory bank
					# REN (bit[16]) = 1, Enable DRAM refresh
					# tRC (bit[19:17]) = 011, 4 cycles (SDRAM mode)
					# tCSR (bit[20]) = 0, 1 cycle
					# Refresh Count Value (bit[31:21]) = 0xCE2 >> 1 = 0x671

#
# LED test
#
# My board use I/O port #0 - port #7 to control LEDs.
# IOPDATA[7:0] : 1 - Led Off, 0 - Led On
#
memset 0x3FF5000 --value=0xFF 		# IOPMOD reg
memset 0x3FF5004 --value=0x00 		# IOPCON reg
memset 0x3FF5008 --value=0xF00		# IOPDATA reg, turn on led