/*
 * arm9tdmi.h : the header file for ARM9TDMI core
 * 
 * Copyright (C) 2003, Rongkai zhan <zhanrk@163.com>, All rights reserved.
 *
 * $Id: arm9tdmi.h,v 1.3 2004/10/17 13:54:32 zhanrk Exp $
 */

#ifndef JTAGER_ARM9TDMI_H
#define JTAGER_ARM9TDMI_H

/* The Test data register lenght of ARM9TDMI */
#define ARM9TDMI_BYPASS_REG_BITNR 	1
#define ARM9TDMI_IDCODE_REG_BITNR 	32
#define ARM9TDMI_INSTRUCTION_REG_BITNR 	4
#define ARM9TDMI_SCANPATH_REG_BITNR 	5

/* the bit length of all scan chains for ARM9TDMI core */
#define ARM9TDMI_SCANCHAIN0_BITNR 	184
#define ARM9TDMI_SCANCHAIN1_BITNR 	67
#define ARM9TDMI_SCANCHAIN2_BITNR 	38

/* ARM9TDMI EmbeddedICE-RT logic's all registers address definition */
#define ARM9TDMI_ICE_DBGCTL	0x00 /* debug control register */
#define ARM9TDMI_ICE_DBGSTAT	0x01 /* debug status register */
#define ARM9TDMI_ICE_VECCATCH	0x02 /* Vector Catch register */
#define ARM9TDMI_ICE_DCC_CTL	0x04
#define ARM9TDMI_ICE_DCC_DATA	0x05
#define ARM9TDMI_ICE_WP0_ADDRVALUE	0x08
#define ARM9TDMI_ICE_WP0_ADDRMASK	0x09
#define ARM9TDMI_ICE_WP0_DATAVALUE	0x0A
#define ARM9TDMI_ICE_WP0_DATAMASK	0x0B
#define ARM9TDMI_ICE_WP0_CTLVALUE	0x0C
#define ARM9TDMI_ICE_WP0_CTLMASK	0x0D
#define ARM9TDMI_ICE_WP1_ADDRVALUE	0x10
#define ARM9TDMI_ICE_WP1_ADDRMASK	0x11
#define ARM9TDMI_ICE_WP1_DATAVALUE	0x12
#define ARM9TDMI_ICE_WP1_DATAMASK	0x13
#define ARM9TDMI_ICE_WP1_CTLVALUE	0x14
#define ARM9TDMI_ICE_WP1_CTLMASK	0x15

#define ARM_NOP	0xE1A00000 /* NOP instruction for ARM core */

extern target_t arm9tdmi_target;

/* from ice.c */
extern int arm9tdmi_ice_read(u32 reg_addr, u32 *reg_val);
extern int arm9tdmi_ice_write(u32 reg_addr, u32 reg_val);
extern int arm9tdmi_ice_set_breakpt(void);
extern int arm9tdmi_ice_clear_breakpt(void);

/* from arm9tdmi.c */
extern int arm9tdmi_setup(void);
extern int arm9tdmi_halt(void);
extern int arm9tdmi_exec_instruction(u32 *writein, u32 *readout, int type);
extern int arm9tdmi_restart(u32 pc);

/* from register.c */
extern u32 arm9tdmi_r0_read(void);
extern void arm9tdmi_r0_write(u32 newval);
extern int arm9tdmi_get_core_state(void);
extern int arm9tdmi_register_read(core_register_t *reg);
extern int arm9tdmi_register_write(core_register_t *reg, u32 value);

/* from memory.c */
extern int arm9tdmi_memory_read8(u8 *buf, u32 address, u32 length);
extern int arm9tdmi_memory_write8(u8 *buf, u32 address, u32 length);
extern int arm9tdmi_memory_read16(u16 *buf, u32 address, u32 length);
extern int arm9tdmi_memory_write16(u16 *buf, u32 address, u32 length);
extern int arm9tdmi_memory_read32(u32 * buf, u32 address, u32 length);
extern int arm9tdmi_memory_write32(u32 * buf, u32 address, u32 length);

#endif /* !JTAGER_ARM9TDMI_H */
