/*
 * cmdline/cmd_exit.c : implements exit/quit command
 *
 * Copyright (C) 2003-2004, Rongkai Zhan <zhanrk@163.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: cmd_exit.c,v 1.2 2004/10/17 08:04:28 zhanrk Exp $ */

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <readline/readline.h>
#include <readline/history.h>

#include "jtager.h"

static int exit_run(int argc, char **argv)
{
	/* exit/quit command needs no params */
	if (argc > 1)
		return print_syntax_error(argv[0]);
	
	/* save JTAGER command history */
	write_history(jtager_history);
	exit(0);
}

cmd_t exit_cmd = {
	.name = "exit",
	.desc = "Exit JTAGER program",
	.alias = "quit",
	.usage = "exit/quit",
	.verbose = NULL,
	.long_options = NULL,
	.optdesc = NULL,
	.non_option_args = 0,

	.run = exit_run,
};
