/*
 * cmdline/cmd_halt.c: implements the JTAGER halt command
 *
 * Copyright (C) 2003-2004, Rongkai Zhan <zhanrk@163.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: cmd_halt.c,v 1.2 2004/10/17 08:04:28 zhanrk Exp $ */

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "jtager.h"
#include "jtag.h"
#include "target.h"

static int halt_run(int argc, char **argv)
{
	int ret;

	/* halt command needs no params */
	if (argc != 1)
		return print_syntax_error(argv[0]);

	ret = t_op->halt();
	if (ret)
		printf("halt: %s", err_str(ret));
	return ret;
}
	
cmd_t halt_cmd = {
	.name = "halt",
	.desc = "Halt the target, and make it into the debug state",
	.alias = NULL,
	.usage = NULL,
	.verbose = NULL,
	.long_options = NULL,
	.optdesc = NULL,
	.non_option_args = 0,

	.run = halt_run
};
