/*
 * flash/flash.c : implements JTAGER's flash interface
 *
 * Copyright (C) 2003, Rongkai Zhan <zhanrk@163.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: flash.c,v 1.2 2004/10/17 08:04:28 zhanrk Exp $ */

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "jtager.h"
#include "target.h"
#include "flash.h"

extern flash_t sst39vf160;
extern flash_t mbm29lv650;

/* all supported flash chips */
flash_t * flashes[] = {
	&mbm29lv650,
	&sst39vf160,
	NULL /* the last element must be NULL */
};

/* current selected flash */
flash_t * flash = NULL;

flash_t * flash_index(char *flash_name)
{
	char *name = flash_name;
	int hit, i;
	flash_t *flash;
	
	i = 0;
	hit = 0;
	while ((flash = flashes[i])) {
		if (strcasecmp(name, flash->name) == 0) {
			hit = 1;
			break;
		}
		i ++;
	}

	if (hit == 0)
		flash = NULL;
	return flash;
} /* end of flash_index(...) */
